Bug 165254 - Review Request: plplot - Scientific plotting package
Review Request: plplot - Scientific plotting package
Status: CLOSED NEXTRELEASE
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
medium Severity medium
: ---
: ---
Assigned To: Ed Hill
David Lawrence
http://www.cora.nwra.com/~orion/fedora
:
Depends On:
Blocks: FE-ACCEPT
  Show dependency treegraph
 
Reported: 2005-08-05 17:55 EDT by Orion Poplawski
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2005-08-10 16:45:56 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
rpmlint output for mock build of plplot-5.5.3-4.fc4 (3.24 KB, text/plain)
2005-08-09 11:10 EDT, Ed Hill
no flags Details

  None (edit)
Description Orion Poplawski 2005-08-05 17:55:01 EDT
Spec Name or Url: http://www.cora.nwra.com/~orion/fedora/plplot.spec
SRPM Name or Url: http://www.cora.nwra.com/~orion/fedora/plplot-5.5.3-1.src.rpm
Description: 

Homepage: http://plplot.sourceforge.net/

PLplot is a library of functions that are useful for making scientific
plots.

PLplot can be used from within compiled languages such as C, C++,
FORTRAN and Java, and interactively from interpreted languages such as
Octave, Python, Perl and Tcl.

The PLplot library can be used to create standard x-y plots, semilog
plots, log-log plots, contour plots, 3D surface plots, mesh plots, bar
charts and pie charts. Multiple graphs (of the same or different sizes)
may be placed on a single page with multiple lines in each graph.

A variety of output file devices such as Postscript, png, jpeg, LaTeX
and others, as well as interactive devices such as xwin, tk, xterm and
Tektronics devices are supported. New devices can be easily added by
writing a small number of device dependent routines.

There are almost 2000 characters in the extended character set. This
includes four different fonts, the Greek alphabet and a host of
mathematical, musical, and other symbols. Some devices supports its own
way of dealing with text, such as the Postscript and LaTeX drivers, or
the png and jpeg drivers that uses the Freetype library.


Note - this is a package that provides lots of interfaces to lots of different libraries/languages.  It probably needs to be broken up into sub-packages so that it doesn't always bring in the kitchen sink.  Any suggestions are appreciated.
Comment 1 Michael Schwendt 2005-08-06 09:09:25 EDT
[Where did the FE-NEW entry go? The form linked in the new NewPackageProcess
page fills it in automatically, doesn't it?]
Comment 2 Ed Hill 2005-08-06 12:00:02 EDT
OK, I'm trying to change this from FE-NEW to RE-REVIEW blocking as I'd like to
be the reviewer.  But I don't see how to assign the bug to me per the directions:

  http://fedoraproject.org/wiki/Extras/NewPackageProcessMarkTwo

Do I need some special permissions to change the assigned-to field or do I just
fill in the QA Contact field?
Comment 3 Michael Schwendt 2005-08-06 23:30:50 EDT
What happens if you use the "Bug Reassignment" radio-buttons and
fields near the bottom of the page?
Comment 4 Ed Hill 2005-08-07 08:25:35 EDT
Hi Michael, I don't have any "Bug Reassignment" radio-buttons and
fields near the bottom of the page.  Please see the screen-shot at:

  http://mitgcm.org/eh3/fedora_misc/bz_165254.png

I'm wondering--is this something that only appears when you have 
additional permissions?
Comment 5 Ed Hill 2005-08-07 11:35:09 EDT
Hi Orion, I started a review but only got this far.  I wish I could 
provide more help tracking down the build failure but it'll have to be 
another day -- not enough free time right now!  :-/

needswork:
  - the Source0 URL doesn't work for me -- but this one did:
      http://prdownloads.sourceforge.net/plplot/plplot-5.5.3.tar.gz
  - please consider shortening the summary to something like:
      "Library of functions for producing scientific plots"
  - build fails on FC-4 (please see below)

good:
  - specfile is nicely formatted -- VERY legible
  - source matches upstream
  - license is indeed LGPL
  - names OK
  - ldconfig looks OK

The build failure (up-to-date FC-4) is some sort of botched code 
generation for the plplot_octave.cc file which I just don't 
understand (but then I spent all of ~15min looking at it):

g++ -c -fPIC -I/usr/include/octave-2.1.71 -I/usr/include/octave-2.1.71/octave
-mieee-fp -O2 -g -pipe -Wp,-D_FORTIFY_SOURCE=2 -fexceptions -m32 -march=i386
-mtune=pentium4 -fasynchronous-unwind-tables -mieee-fp -I. -I. plplot_octave.cc
-o plplot_octave.o
./massage >> plplot_stub.m 2> missing_help
plplot_octave.cc: In function 'octave_value_list _wrap_plscol0(const
octave_value_list&, int)':
plplot_octave.cc:2239: error: 'nt' was not declared in this scope
plplot_octave.cc:2239: error: expected `;' before ')' token
make[4]: *** [plplot_octave.oct] Error 1
make[4]: Leaving directory
`/home/edhill/rpmbuild/BUILD/plplot-5.5.3/bindings/octave'
Comment 6 David Lawrence 2005-08-07 12:32:52 EDT
(In reply to comment #4)
> Hi Michael, I don't have any "Bug Reassignment" radio-buttons and
> fields near the bottom of the page.  Please see the screen-shot at:
> 
>   http://mitgcm.org/eh3/fedora_misc/bz_165254.png
> 
> I'm wondering--is this something that only appears when you have 
> additional permissions?


Are you logged in properly? (username visible at the top right of each bz page).
Also if you are not the reporter, you will need 'editbugs' privileges to edit
other people's bugs such as status changes, etc. Please speak with Elliot
(sopwith@redhat.com) to have your username added to the Fedora Contrib Bugzilla
group. This would happen automatically if you have CVS access to Fedora Extras.
Comment 7 Ed Hill 2005-08-07 13:27:47 EDT
Hi David, I am logged in properly (user: "ed@eh3.com") and I sent a private
"please help me" email to Elliot (in which I accidentally called you "Greg" so
*please* forgive me!).
Comment 8 Orion Poplawski 2005-08-08 11:58:37 EDT
I've put new versions up at http://www.cora.nwra.com/~orion/fedora/

It's fun being the first test bunny... 
Comment 9 Orion Poplawski 2005-08-08 13:44:51 EDT
Okay, another new version (-3) at  http://www.cora.nwra.com/~orion/fedora/. 
This is based on the plplot-split.spec, which attempts to split the package up
into several sub-packages to try to reduce dependencies.  Let me know what you
think.  It does the major ones: gnome, octave, and tk.  Since python is usually
installed I haven't split that out.
Comment 10 Ed Hill 2005-08-08 14:11:24 EDT
Hi Orion, on my FC-4 system the -3 version fails to build with a lot of 
errors that all say the same thing ("plplotjavac cannot be resolved") 
and it looks like (?) a classpath problem.

===
cp plplot/core/plplotjavacConstants.class .
javac   plplotjavac.java -d . -classpath .
cp plplot/core/SWIGTYPE_p_p_char.class .
javac   PLStream.java -d . -classpath .
----------
1. ERROR in PLStream.java
 (at line 67)
        plplotjavac.plsstrm(stream_id);
        ^^^^^^^^^^^
plplotjavac cannot be resolved
----------
2. ERROR in PLStream.java
 (at line 108)
        plplotjavac.pl_setcontlabelformat(lexp, sigdig);
        ^^^^^^^^^^^
plplotjavac cannot be resolved
Comment 11 Ralf Corsepius 2005-08-09 11:06:34 EDT
I haven't checked all details, but as it seems to me, when rebuilding the
package outside of a buildsystem, the configure script picks up arbitrary
features, depending on which packages are installed on a system.

So, I'd suggest you to check if you need to append --disable-<feature> or
--with-<package>=no to %configure to make building the package deterministic.
Comment 12 Ed Hill 2005-08-09 11:10:34 EDT
Created attachment 117575 [details]
rpmlint output for mock build of plplot-5.5.3-4.fc4
Comment 13 Ed Hill 2005-08-09 11:14:15 EDT
Hi Orion, the version:

  http://www.cora.nwra.com/~orion/fedora/plplot-5.5.3-4.src.rpm

built in mock on FC-4 but resulted in a few rpmlint errors and warnings which 
I created as attachment 117575 [details] (above).  I think some of the libexec stuff can 
be safely ignored but others probably need work.
Comment 14 Orion Poplawski 2005-08-09 12:35:53 EDT
Okay, released -5 which cleans up a bunch of rpmlint issues and explicitly turns
off unused options with configure.  It also adds %check/make check and some
fixes to some problems that that turned up.

I still get the following rpmlint messages, but I'm going to ignore them:

W: plplot-gnome summary-not-capitalized plplot funtions for gnome
W: plplot-gnome no-documentation
W: plplot-tk summary-not-capitalized plplot funtions for tk
E: plplot-tk no-dependency-on locales-tk
W: plplot-gnome-devel summary-not-capitalized plplot libraries for gnome
W: plplot-gnome-devel no-documentation
W: plplot-octave summary-not-capitalized plplot funtions for octave
W: plplot-octave no-documentation
W: plplot-octave non-standard-dir-in-usr libexec
W: plplot-tk-devel summary-not-capitalized plplot libraries for tk
W: plplot-tk-devel no-documentation
E: plplot-tk-devel wrong-script-interpreter
/usr/share/plplot5.5.3/examples/tk/tk01 "xtk01"
E: plplot-tk-devel wrong-script-interpreter
/usr/share/plplot5.5.3/examples/tk/tk04 "xtk04"
E: plplot-tk-devel wrong-script-interpreter
/usr/share/plplot5.5.3/examples/tk/tk02 "xtk02"

The last 3 are spurious because the example sripts really do run with a
different interpreter.
Comment 15 Michael Schwendt 2005-08-09 12:44:46 EDT
W: plplot-gnome summary-not-capitalized plplot funtions for gnome
W: plplot-tk summary-not-capitalized plplot funtions for tk
W: plplot-gnome-devel summary-not-capitalized plplot libraries for gnome
W: plplot-octave summary-not-capitalized plplot funtions for octave
W: plplot-tk-devel summary-not-capitalized plplot libraries for tk

Surely it is common to fix these. (Even openSUSE have guidelines for this.)
In these cases:

 * Capitalise first character.
 * Don't repeat package name at beginning of Summary.
 * s/funtions/functions/g

E.g.

plplot-gnome : Functions for scientific plotting with GNOME
plplot-tk : Functions for scientific plotting with Tk
plplot-gnome-devel : Development files for using PLplot GNOME
plplot-octave : Functions for scientific plotting with Octave
plplot-tk-devel : Development files for using PLplot with Tk

or similar.
Comment 16 Orion Poplawski 2005-08-09 12:53:21 EDT
True, I'll stop being lazy.  Repushed -5 with updated summaries.
Comment 17 Ed Hill 2005-08-10 12:57:39 EDT
Hi Orion, the package is looking good and heres the second half of the 
review that started in comment #5

needswork:
 - rpmlint reports:

     W: plplot-gnome no-documentation
     W: plplot-gnome-devel no-documentation
     W: plplot-octave no-documentation
     W: plplot-octave non-standard-dir-in-usr libexec
     E: plplot-tk no-dependency-on locales-tk
     W: plplot-tk-devel no-documentation
     E: plplot-tk-devel wrong-script-interpreter 
          /usr/share/plplot5.5.3/examples/tk/tk01 "xtk01"
     E: plplot-tk-devel wrong-script-interpreter
          /usr/share/plplot5.5.3/examples/tk/tk04 "xtk04"
     E: plplot-tk-devel wrong-script-interpreter
          /usr/share/plplot5.5.3/examples/tk/tk02 "xtk02"

   where I think everything can be safely ignored except for the
   "no-dependency-on locales-tk" which I just don't understand.
   Hopefully, someone else can explain it.  Anyone...?

 - plplot-gnome and plplot-tk both install shared libs so 
   please add a set of %post/%postun -p /sbin/ldconfig entries 
   for those two sub-packages

good:
 - needswork items from #5 are now OK
 - dir ownership looks OK
 - permissions look OK
 - code not content OK
 - use of -devel looks good
 - builds in mock on FC-4

Since the remaining bits appear to be minor, please fix them in 
CVS before the first build and I'll APPROVE.
Comment 18 Ville Skyttä 2005-08-10 13:15:11 EDT
locales-tk stuff from rpmlint is bug 165457. 
Comment 19 Orion Poplawski 2005-08-10 16:45:56 EDT
Added the post/postun ldconfig

Checked in and builds on FC-4 (with a fix for x86_64).  Working on devel...

Thanks Ed!
Comment 20 Ed Hill 2005-08-10 17:06:35 EDT
Cool, I'm glad that its working and am looking forward to giving 
it a try.  One of the unexpected (for me, anyway) benefits of FE is 
finding out about these useful progects/libs/etc.  Who knew all this 
stuff existed?

Note You need to log in before you can comment on or make changes to this bug.